////////////////////////////////////////////////////////////////////////////////
/** @brief 汎用入出力ポートの設定関数
@date 2012/3/19
*///////////////////////////////////////////////////////////////////////////////
#include <stm32f4xx.h>

////////////////////////////////////////////////////////////////////////////////
/** @brief 汎用出力ポートの設定を行う
@note
使用するポートのコメントアウトをはずせば良いようになっている．
なお，PC13, PC14, PC15は電流値が制限されているので使用しない方が良い．
何も設定しなければ入力として機能するはずなので入力ポートについては
クロックを有効にする以外の設定はしない．
@return なし
*///////////////////////////////////////////////////////////////////////////////
void GPIO_config()
{
	// クロックを有効にする
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE);
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOC, ENABLE);
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE);

	// 出力用にポートを設定
	GPIO_InitTypeDef GPIO_InitStructure;
	GPIO_StructInit(&GPIO_InitStructure);
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_100MHz;
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_NOPULL;
	// ポートA
	GPIO_InitStructure.GPIO_Pin = 0;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_0;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_1;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_2;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_3;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_4;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_5;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_6;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_7;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_8;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_9;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_10;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_11;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_12;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_13;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_14;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_15;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	// ポートB
	GPIO_InitStructure.GPIO_Pin = 0;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_0;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_1;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_2;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_3;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_4;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_5;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_6;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_7;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_8;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_9;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_10;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_11;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_12;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_13;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_14;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_15;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	// ポートC
	GPIO_InitStructure.GPIO_Pin = 0;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_0;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_1;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_2;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_3;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_4;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_5;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_6;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_7;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_8;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_9;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_10;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_11;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_12;
	GPIO_Init(GPIOC, &GPIO_InitStructure);
	// ポートD
	GPIO_InitStructure.GPIO_Pin = 0;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_0;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_1;
//	GPIO_InitStructure.GPIO_Pin |= GPIO_Pin_2;
	GPIO_Init(GPIOD, &GPIO_InitStructure);
}


/// example
void on_LED1()
{
	GPIO_SetBits(GPIOA, GPIO_Pin_0);
}


/// example
volatile int sw1()
{
	return GPIO_ReadInputDataBit(GPIOB, GPIO_Pin_1);
}

